c
c $Id: symm_ident.f,v 1.1.1.1 2003/08/06 02:45:29 natalie Exp $
c
c $Log: symm_ident.f,v $
c Revision 1.1.1.1  2003/08/06 02:45:29  natalie
c PWPAW source code implemented on Osiris
c
c Revision 1.1  1991/12/16  00:07:11  alberto
c Initial revision
c
      subroutine symm_ident(ntrans,mtrx,tnp,id)
c
      implicit none
c
      integer ntrans
      integer mtrx(48,3,3)
      double precision tnp(48,3)
      character id(48)*10
c
      integer i,j, oper, ierr, ipt
      logical proper, nonsym(48)
      double precision det, trace, te, tt
      integer iv1(3)
      double precision a(3,3), z(3,3), wr(3), wi(3), fv1(3)
      double precision t(3), e(3), canon_t(3)
      double precision rdot
      character*2 axes(-2:2)
c
      data axes / 'C2', 'C3', 'C4', 'C6', 'E ' /
c
      do 100 oper = 1, ntrans
c
c       Copy the matrix to a double precision format for
c       processing with EISPACK. Also, copy the non-primitive
c       translation.
c      
        do 20 i = 1, 3
          do 10 j = 1 , 3
            a(i,j) = mtrx(oper,i,j)
            t(j) = tnp(48,j)
  10      continue
  20    continue
c
c       Compute determinant  and trace
c       
        det = a(1,1)*a(2,2)*a(3,3) + a(2,1)*a(3,2)*a(1,3) +
     &        a(1,2)*a(2,3)*a(3,1) - a(3,1)*a(2,2)*a(1,3) -
     &        a(2,1)*a(1,2)*a(3,3) - a(1,1)*a(3,2)*a(2,3)
c
        proper = (nint(det) .eq. 1)
c
        trace = a(1,1) + a(2,2) + a(3,3)
c
        if (proper) then
c
c           Proper operation
c
            id(oper) = axes(nint(trace - 1))
c
        else
c
c           R = IS , where S is proper
c
            call sscal(9,-1.d0,a,1)
            id(oper) = 'I' // axes(nint(-trace - 1))
c
        endif
c
c       Find eigenvector of a with eigenvalue = +1 (vector
c       parallel to the axis.
c
c        call rg(3,3,a,wr,wi,1,z,iv1,fv1,ierr)
c
c        do 40 i = 1, 3
c           if ( abs( dcmplx(wr(i),wi(i)) - (1.d0,0.d0) )
c     &          .lt. 1.d-8 ) ipt = i 
c   40   continue
cc
cc       Get the correct eigenvector
cc
c        call scopy(3,z(1,ipt),1,e,1)
cc
cc       Perform the dot product with t:
cc
c        te = rdot(e,t)
cc
c        nonsym(oper) = .false.
cc
c        if (proper) then
cc
c          if (abs(te) .gt. 1.d-8) then
cc
c            nonsym(oper) = .true.
c            call scopy(3,e,1,canon_t,1)
c            call sscal(3,te,canon_t,1)
cc
c          endif
cc
c        else
cc
c          tt = rdot(t,t)
c          if (abs(te) - sqrt(tt) .gt. 1.d-8) then
cc
c             nonsym(oper) = .true.
c             call scopy(3,t,1,canon_t,1)
c             call saxpy(3,-te,e,1,canon_t,1)
cc
c          endif
cc
c        endif       
cc
c        if (nonsym(oper)) id(oper) = id(oper) // '*'
c
  100 continue
c
      return
c
      end
