  SUBROUTINE 3dElect

    Complex, allocatable :: V_static(:)
    Integer   :: ig
    Real      :: con

   
   Allocate(V_static(Gpnt_size(G_HIGH)),stat=ig)
        if (ig.ne.0) then
           write(Error_Unit,*) 'allocation error in 3dElect', &
                         Gpnt_size(G_HIGH),ig
           stop
        endif

   V_static=0
   V_static=SCFvalues%RhoSmooth+SCFvalues%RhoHat+SCFvalues%CoreTail
   if (spindependence) V_static=V_static+SCFvalues%RhoSmoothspin

   con=2*13.60569193d0*Four_Pi/xtal%Volume    ! eV units for V_static
   V_static(1)=0
   do ig=2,Gpnt_size(G_HIGH)
      V_static(ig)=con*V_static(ig)/Gpnt(4,gi)**2
   enddo

   Call 3dGridPlot(V_static)

   deallocate(V_static)

  END SUBROUTINE 3dElect
