!******************************************************************************
!
! File : btree_data.f90
!   by : Alan Tackett
!   on : 07/16/99
!  for : PAW program
!
!  Btree data structures
!
!******************************************************************************

Module btree_data

Implicit NONE!!!!!!!!!!!!!


Type BinaryTreeData   !** Define the information stored
     Type (BinaryTreeData), Pointer :: Level_Next !*Link to next point/level
     Real    :: Gmag          !** Mag of G
     Integer :: Npnt(3)       !** Integer version of G
End type

Type BinaryTreeNode   !** Define the btree node
     Type (BinaryTreeNode), Pointer :: LeftChild      !* children
     Type (BinaryTreeNode), Pointer :: RightChild
     Type (BinaryTreeData), Pointer :: Info           !* pointer to data
     Integer                        :: BalanceFactor  !* relative branch ht
End Type

End Module


