!***************************************************************************
!
! File : paw_end.f90
!   by : Alan Tackett
!   on : 7/26/98
!  for : PAW Project
!
!
!  PAW_End - Performs an orderly close of the PAW program
!
!***************************************************************************

Subroutine paw_End
  Use paw_inout
  Use word
  Use timing

  Implicit NONE!!!!

  character*100 :: msg

  Call Print_Timers(Log_Unit)

  msg = 'Exiting PAW program'

  Write(Output_Unit, *) msg
  Write(Error_Unit, *) msg
  Write(Log_Unit, *) msg

  !Call SendQuit

  STOP
  Return
End Subroutine
