!---
! $Id: symmetry.h,v 1.1.1.1 2003/08/06 02:45:29 natalie Exp $
!
! $Log: symmetry.h,v $
! Revision 1.1.1.1  2003/08/06 02:45:29  natalie
! PWPAW source code implemented on Osiris
!
! Revision 1.1  1991/12/15  23:56:21  alberto
! Initial revision
!
!     symmetry.h
!
!     ntrans is the number of point group operations.
!
!     gmtrx is the matrix of rotations in g-lattice coordinates.
!     rmtrx is the matrix of rotations in r-lattice coordinates.
!
!     tnp(oper,ilat) is the fractional translation in latt. coor.
!
      integer ntrans, rmtrx(48,3,3), gmtrx(48,3,3), cmtrx(48,3,3)
      Real tnp(48,3)
!
      common /symm_ops/ tnp, ntrans, rmtrx, gmtrx, cmtrx
      save /symm_ops/
!---
